class License < ActiveRecord::Base
  has_one :original_license
  has_one :common_license
  validates :name, :presence => true, :length => {:maximum => 50}
  validates :url, :presence => true, :length => {:maximum => 200}, :uniqueness => true
  
  def self.update_license cl
    l = License.find_by_url cl.url
    l = License.new unless l
    l.attributes = {
      :name => cl.name, :url => cl.url, :cc_by => cl.cc_by, :cc_sa => cl.cc_sa, :cc_nd => cl.cc_nd, :cc_nc => cl.cc_nc, 
      :no_resize => cl.no_resize, :no_flip => cl.no_flip, :no_convert => cl.no_convert, :keep_aspect_ratio => cl.keep_aspect_ratio
    }
    if cl.new_record? and l.new_record? == false
      l.errors.add :base, 'dupulicate url'
    end
    l
  end
  
  def self.default_page_size
    25
  end
  
  def self.max_page_size
    100
  end
  
  def self.page prm = nil
    page = prm.to_i
    page = 1 if page < 1
    page
  end
  
  def self.page_size prm = self.default_page_size
    page_size = prm.to_i
    page_size = self.max_page_size if page_size > self.max_page_size
    page_size = self.default_page_size if page_size < 1
    page_size
  end
  
  def self.offset cnt, prm = nil
    offset = prm.to_i
    offset = cnt - 1 if offset >= cnt
    offset = cnt - offset.abs if offset < 0
    offset = 0 if offset < 0
    offset
  end
  
  def self.list opt = {}, page = 1, page_size = self.default_page_size
    opt.merge!(self.list_opt) unless opt[:include]
    opt.merge!({:order => 'name', :limit => page_size, :offset => (page -1) * page_size})
    License.find(:all, opt)
  end
  
  def self.list_opt
    {:include => {:common_license => {}, :original_license => {}}}
  end
  
  def self.list_json_opt
    {:include => {:common_license => {}, :original_license => {}}}
  end
  
  def self.show rid, opt = {}
    r = License.find(rid, :include => self.show_include_opt(opt))
#    raise ActiveRecord::Forbidden unless c.visible?(au)
    r
  end
  
  def self.show_include_opt opt = {}
    res = [:common_license, :original_license]
    res.push(opt[:include]) if opt[:include]
    res
  end
  
  def self.show_json_include_opt
    {:include => {:common_license => {}, :original_license => {}}}
  end
  
end
