require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe SpeachBalloonTemplatesController do

  # This should return the minimal set of attributes required to create a valid
  # SpeachBalloonTemplate. As you add validations to SpeachBalloonTemplate, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all speach_balloon_templates as @speach_balloon_templates" do
      speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
      get :index
      assigns(:speach_balloon_templates).should eq([speach_balloon_template])
    end
  end

  describe "GET show" do
    it "assigns the requested speach_balloon_template as @speach_balloon_template" do
      speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
      get :show, :id => speach_balloon_template.id
      assigns(:speach_balloon_template).should eq(speach_balloon_template)
    end
  end

  describe "GET new" do
    it "assigns a new speach_balloon_template as @speach_balloon_template" do
      get :new
      assigns(:speach_balloon_template).should be_a_new(SpeachBalloonTemplate)
    end
  end

  describe "GET edit" do
    it "assigns the requested speach_balloon_template as @speach_balloon_template" do
      speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
      get :edit, :id => speach_balloon_template.id
      assigns(:speach_balloon_template).should eq(speach_balloon_template)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new SpeachBalloonTemplate" do
        expect {
          post :create, :speach_balloon_template => valid_attributes
        }.to change(SpeachBalloonTemplate, :count).by(1)
      end

      it "assigns a newly created speach_balloon_template as @speach_balloon_template" do
        post :create, :speach_balloon_template => valid_attributes
        assigns(:speach_balloon_template).should be_a(SpeachBalloonTemplate)
        assigns(:speach_balloon_template).should be_persisted
      end

      it "redirects to the created speach_balloon_template" do
        post :create, :speach_balloon_template => valid_attributes
        response.should redirect_to(SpeachBalloonTemplate.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved speach_balloon_template as @speach_balloon_template" do
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBalloonTemplate.any_instance.stub(:save).and_return(false)
        post :create, :speach_balloon_template => {}
        assigns(:speach_balloon_template).should be_a_new(SpeachBalloonTemplate)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBalloonTemplate.any_instance.stub(:save).and_return(false)
        post :create, :speach_balloon_template => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested speach_balloon_template" do
        speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
        # Assuming there are no other speach_balloon_templates in the database, this
        # specifies that the SpeachBalloonTemplate created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        SpeachBalloonTemplate.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => speach_balloon_template.id, :speach_balloon_template => {'these' => 'params'}
      end

      it "assigns the requested speach_balloon_template as @speach_balloon_template" do
        speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
        put :update, :id => speach_balloon_template.id, :speach_balloon_template => valid_attributes
        assigns(:speach_balloon_template).should eq(speach_balloon_template)
      end

      it "redirects to the speach_balloon_template" do
        speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
        put :update, :id => speach_balloon_template.id, :speach_balloon_template => valid_attributes
        response.should redirect_to(speach_balloon_template)
      end
    end

    describe "with invalid params" do
      it "assigns the speach_balloon_template as @speach_balloon_template" do
        speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBalloonTemplate.any_instance.stub(:save).and_return(false)
        put :update, :id => speach_balloon_template.id, :speach_balloon_template => {}
        assigns(:speach_balloon_template).should eq(speach_balloon_template)
      end

      it "re-renders the 'edit' template" do
        speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SpeachBalloonTemplate.any_instance.stub(:save).and_return(false)
        put :update, :id => speach_balloon_template.id, :speach_balloon_template => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested speach_balloon_template" do
      speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
      expect {
        delete :destroy, :id => speach_balloon_template.id
      }.to change(SpeachBalloonTemplate, :count).by(-1)
    end

    it "redirects to the speach_balloon_templates list" do
      speach_balloon_template = SpeachBalloonTemplate.create! valid_attributes
      delete :destroy, :id => speach_balloon_template.id
      response.should redirect_to(speach_balloon_templates_url)
    end
  end

end
